package repository

import (
	// "time"

	"github.com/google/uuid"
	"gitlab.informatika.org/k-01-11/graduit-be/src/module/batch_sidang/entity"
	"gorm.io/gorm"
)

type BatchSidangRepo struct {
	DBWrite *gorm.DB
	DBRead  *gorm.DB
}

func NewBatchSidangRepository(dbWrite *gorm.DB, dbRead *gorm.DB) *BatchSidangRepo {
	return &BatchSidangRepo{
		DBWrite: dbWrite,
		DBRead:  dbRead,
	}
}

func (repo *BatchSidangRepo) NewBatchSidang(batchSidang entity.BatchSidang) (output entity.BatchSidang, err error) {
	batchSidang.IDBatch = uuid.New().String()

	result := repo.DBWrite.Create(&batchSidang)
	if result.Error != nil {
		return entity.BatchSidang{}, result.Error
	}
	return batchSidang, nil
}

func (repo *BatchSidangRepo) GetSidangBatches() (output []entity.BatchSidang, err error) {
	var batches []entity.BatchSidang
	result := repo.DBRead.Find(&batches)
	if result.Error != nil {
		return nil, err
	}
	return batches, nil
}

func (repo *BatchSidangRepo) DeleteBatch(id string) (entity.BatchSidang, error) {
	batch := entity.BatchSidang{IDBatch: id}
	err := repo.DBWrite.Delete(&batch).Error

	if err != nil {
		return batch, err
	}

	return batch, err
}
