package repository

import (
	"time"

	"github.com/google/uuid"
	"gitlab.informatika.org/k-01-11/graduit-be/src/module/bimbingan_log/entity"
	"gorm.io/gorm"
)

type BimbinganLogRepo struct {
	DBWrite *gorm.DB
	DBRead  *gorm.DB
}

func NewBimbinganLogRepository(dbWrite *gorm.DB, dbRead *gorm.DB) *BimbinganLogRepo {
	return &BimbinganLogRepo{
		DBWrite: dbWrite,
		DBRead:  dbRead,
	}
}

func (repo *BimbinganLogRepo) NewBimbinganLog(bimbinganLog entity.BimbinganLog) (output entity.BimbinganLog, err error) {
	bimbinganLog.ID = uuid.New().String()

	bimbinganLog.CreatedAt = time.Now()
	result := repo.DBWrite.Create(&bimbinganLog)
	if result.Error != nil {
		return entity.BimbinganLog{}, result.Error
	}
	return bimbinganLog, nil
}

func (repo *BimbinganLogRepo) GetBimbinganLogByStudentId(limit int, offset int, idMahasiswa string) (output []entity.BimbinganLog, err error) {
	var bimbinganLogs []entity.BimbinganLog
	result := repo.DBRead.Where("id_mahasiswa = ?", idMahasiswa).Limit(limit).Offset(offset).Find(&bimbinganLogs)
	if result.Error != nil {
		return nil, err
	}
	return bimbinganLogs, nil
}
