package usecase

import (
	"gitlab.informatika.org/k-01-11/graduit-be/src/module/bimbingan_log/entity"
	"gitlab.informatika.org/k-01-11/graduit-be/src/utils"
)

type BimbinganLogUsecase interface {
	AddBimbinganLog(bimbinganLog entity.BimbinganLog) (entity.BimbinganLog, error)
	GetBimbinganLog(param utils.LimitOffset, idMahasiswa string) ([]entity.BimbinganLog, error)
}

type BimbinganLogUc struct {
	bimbinganLogRepo BimbinganLogRepository
}

func NewBimbinganLogUseCase(bimbinganLogRepo BimbinganLogRepository) *BimbinganLogUc {
	return &BimbinganLogUc{
		bimbinganLogRepo: bimbinganLogRepo,
	}
}

func (uc *BimbinganLogUc) AddBimbinganLog(bimbinganLog entity.BimbinganLog) (entity.BimbinganLog, error) {
	newBimbinganLog, err := uc.bimbinganLogRepo.NewBimbinganLog(bimbinganLog)

	if err != nil {
		return newBimbinganLog, err
	}

	return newBimbinganLog, nil

}

func (uc *BimbinganLogUc) GetBimbinganLog(param utils.LimitOffset, idMahasiswa string) ([]entity.BimbinganLog, error) {
	return uc.bimbinganLogRepo.GetBimbinganLogByStudentId(param.Limit, param.Offset, idMahasiswa)
}
