package entity

import "time"

type Pendaftaran struct {
	Id          string `gorm:"type:uuid;primaryKey;default:gen_random_uuid();unique"` // UUID as a string
	IdTopik     string
	IdMahasiswa string
	IdDosen     string
	Status      *bool      `gorm:"default:null"`
	InterviewAt *time.Time `gorm:"default:null"`
	DecidedAt   *time.Time `gorm:"default:null"`
	CreatedAt   time.Time  `gorm:"autoCreateTime"` // Use this if you want to override the gorm.Model's CreatedAt
	UpdatedAt   time.Time  `gorm:"autoUpdateTime"` // Use this if you want to override the gorm.Model's UpdatedAt
}

type ParamValues struct {
	Limit  int
	Offset int
}

type PendaftaranAddRequest struct {
	IdTopik     string
	IdMahasiswa string
	IdDosen     string
}

type UpdatePendaftaranRequest struct {
	Id     string
	Status bool
}

type WaktuInterviewUpdateRequest struct {
	Id          string
	InterviewAt time.Time
}
