package entity

import (
	"time"
)

type StatusMahasiswa struct {
	IdMahasiswa string `json:"id_mahasiswa"`
	Nama        string `json:"nama"`
	NIM         string `json:"nim"`

	StatusPendaftaran StatusPendaftaran `json:"status_pendaftaran"`
	StatusBimbingan   StatusBimbingan   `json:"status_bimbingan"`
	StatusSeminar     StatusSeminar     `json:"status_seminar"`
	StatusSidang      StatusSidang      `json:"status_sidang"`
}

type StatusPendaftaran struct {
	Status                     bool      `json:"status"`
	Topik                      string    `json:"topik"`
	Judul                      string    `json:"judul"`
	DosenPembimbing            string    `json:"dosen_pembimbing"`
	PengirimanRegistrasi       time.Time `json:"pengiriman_registrasi"`
	PersetujuanDosenPembimbing time.Time `json:"persetujuan_dosen_pembimbing"`
	JadwalInterview            time.Time `json:"jadwal_interview"`
	PengesahanDosenPembimbing  bool      `json:"pengesahan_dosen_pembimbing"`
}

type StatusBimbingan struct {
	JumlahBimbingan int `json:"jumlah_bimbingan"`
}

type StatusSeminar struct {
	Status        bool      `json:"status"`
	DosenPenguji  string    `json:"dosen_penguji"`
	JadwalSeminar time.Time `json:"jadwal_seminar"`
	Ruangan       string    `json:"ruangan"`
}

type StatusSidang struct {
	Status        bool      `json:"status"`
	DosenPenguji1 string    `json:"dosen_penguji_1"`
	DosenPenguji2 string    `json:"dosen_penguji_2"`
	JadwalSeminar time.Time `json:"jadwal_seminar"`
	Ruangan       string    `json:"ruangan"`
}
