package usecase

import "gitlab.informatika.org/k-01-11/graduit-be/src/module/status_mahasiswa/entity"

type StatusMahasiswaUseCase interface {
	GetStatusMahasiswa(nim string) ([]entity.StatusMahasiswa, error)
}

type StatusMahasiswaUc struct {
	statusMahasiswaRepo StatusMahasiswaRepository
}

func NewStatusMahasiswaUsecase(statusMahasiswaRepo StatusMahasiswaRepository) *StatusMahasiswaUc {
	return &StatusMahasiswaUc{
		statusMahasiswaRepo: statusMahasiswaRepo,
	}
}

func (uc *StatusMahasiswaUc) GetStatusMahasiswa(nim string) ([]entity.StatusMahasiswa, error) {
	newStatusMahasiswa, err := uc.statusMahasiswaRepo.GetStatusMahasiswaByNIM(nim)

	if err != nil {
		return newStatusMahasiswa, err
	}

	return newStatusMahasiswa, nil
}
